datablock PlayerData(PlayerHoming : PlayerStandardArmor)
{
	runForce = 100 * 35;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 30;
   maxBackwardSpeed = 20;
   maxSideSpeed = 20;
   
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "Sonic-Like Player";
	showEnergyBar = false;
};

datablock PlayerData(PlayerHomingBoost : PlayerStandardArmor)
{
	runForce = 100 * 50;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 50;
   maxBackwardSpeed = 1;
   maxSideSpeed = 1;
   
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	showEnergyBar = false;
};

datablock AudioProfile(PlayerHoming_Boost)
{
	filename = "./boost.wav";
	description = AudioDefault3d;
	preload = true;
};

datablock AudioProfile(PlayerHoming_BoostEnd)
{
	filename = "./boostend.wav";
	description = AudioDefault3d;
	preload = true;
};

datablock AudioProfile(PlayerHoming_Homing)
{
	filename = "./homing.wav";
	description = AudioDefault3d;
	preload = true;
};

datablock ParticleData(JumpBallParticle)
{
   dragCoefficient = 0;
   gravityCoefficient = 0;
   inheritedVelFactor = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS = 1000;
   lifetimeVarianceMS = 100;
   useInvAlpha = false;
   textureName = "./ballemitter.png";
   colors[0] = "1 1 1";
   colors[1] = "1 1 1";
   colors[2] = "1 1 1";
   sizes[0] = 0.4;
   sizes[1] = 1;
   sizes[2] = 0.1;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 1.0;
};

datablock ParticleEmitterData(JumpBallEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.2;
   ejectionOffset = 1.0;
   velocityVariance = 0.1;
   thetaMin = 0;
   thetaMax = 120;
   phiReferenceVel = 0;
   phiVariance = 360;
   overrideAdvance = false;
   particles = "JumpBallParticle";
   uiName = "BlueBallTest";
};

datablock ShapeBaseImageData(JumpBallImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	
	mountPoint = $HipSlot;
	
	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "Next";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "Next";
	stateTransitionOnTimeout[1]		= "Last";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 1;
	stateEmitter[1]					= JumpBallEmitter;
	stateEmitterTime[1]				= 1;

	stateName[2]					= "Last";
	stateScript[2]					= "onDone";
};

datablock ShapeBaseImageData(BoostImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	
	mountPoint = $HipSlot;
	
	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "Next";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "Next";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 1;
	stateEmitter[1]					= JumpBallEmitter;
	stateEmitterTime[1]				= 1;
};

function JumpBallImage::onDone(%this,%obj,%slot)
{
	%obj.unmountImage(%slot);
}

if(!isObject(HBTargets))
	new ScriptGroup(HBTargets);

registerOutputEvent("Player","addBoost","int -100 100 5");
registerOutputEvent("Player","setBoost","int -100 100 5");
	
function Player::addBoost(%this,%ammount)
{
	%this.boost += %ammount;
	%this.client.bottomPrint("\c6You got \c4"@%ammount@"\c6 boost points!",2);
}

function Player::setBoost(%this,%ammount)
{
	%this.boost = %ammount;
	%this.client.bottomPrint("\c6You now have \c4"@%ammount@"\c6 boost points.",2);
}
	
package PlayerHoming
{
	function FXDtsBrick::onPlant(%this)
	{
		parent::onPlant(%this);
		if(%this.colorID == 17)
		{
			%obj = new ScriptObject("HBTarg_"@%this)
			{
				brick = %this;
			};
			%this.HBObject = %obj;
			HBTargets.add(%obj);
		}
	}
	function FXDtsBrick::onDeath(%this)
	{
		if(%this.colorID == 17)
		{
			HBTargets.remove(%this.HBObject);
			%this.HBObject.delete();
			%this.HBObject = "";
		}
		parent::onDeath(%this);
	}
	
	function PlayerHomingBoost::onTrigger(%this,%player,%slot,%val)
	{
		parent::onTrigger(%this,%player,%slot,%val);
		if(%slot == 4 && !%val)
		{
			if(%player.isBoosting)
			{
				%player.isBoosting = 0;
				cancel(%player.boostTick);
				%player.unmountImage(1);
				%player.setDatablock(PlayerHoming);
				commandToClient(%player.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
			}
			%player.playAudio(2,PlayerHoming_BoostEnd);
		}
	}
	
	function PlayerHoming::onTrigger(%this,%player,%slot,%val)
	{
		parent::onTrigger(%this,%player,%slot,%val);
		if(%slot == 4)
		{
			if(%val)
			{
				%player.isBoosting = 1;
				if(%player.boost > 0)
				{
					if(vectorDist(%player.getPosition(),%player.lastPos) < 1)
					{
						%player.client.bottomPrint("\c6You need to be moving to be able to \c4Boost!",2);
						%player.setDatablock(PlayerHoming);
						%player.isBoosting = 0;
						%player.unmountImage(1);
						commandToClient(%player.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
						return;
					}
					HomingPlayer_BoostTick(%player);
					%player.playAudio(2,PlayerHoming_Boost);
				}
				else
				{
					%player.client.bottomPrint("<just:center>\c6You ran out of\c4 Boost\c6!",2);
				}
			}
		}
		if(%slot == 2 && %val)
		{
			if(%player.readyToHome)
			{
				%player.readyToHome = 0;
				%target = HomingPlayer_findClosestTarget(%player);
				%a = getWord(%player.getPosition(),2);
				%b = getword(%target,2);
				cancel(%player.canHomeSche);
				if(%target != 0 && %a - %b < 10)
				{
					if(!%player.canHome)
						return;
					%player.mountImage(JumpBallImage,3);
					cancel(%player.nerfVel);
					%player.canHome = 0;
					%player.isHoming = 1;
					%velocity = vectorScale(vectorSub(%target,%player.getPosition()),7);
					%player.setVelocity(%velocity);
					%player.playThread(0,"ArmReadyBoth");
					%player.playThread(1,"sit");
					%player.HBTarget = %target;
					schedule(1000,0,HomingPlayer_stand,%player);
					%player.nerfVel = schedule(4000,0,homingPlayer_nerfVel,%player);
					%player.playAudio(1,PlayerHoming_Homing);
				}
				else
				{
					if(!%player.canHome)
						return;
					%player.mountImage(JumpBallImage,3);
					cancel(%player.nerfVel);
					%player.canHome = 0;
					%player.isHoming = 1;
					%player.setVelocity(getWords(vectorScale(%player.getForwardVector(),30),0,1) SPC "10");
					%player.playThread(0,"ArmReadyBoth");
					%player.playThread(1,"sit");
					schedule(1000,0,HomingPlayer_stand,%player);
					%player.playAudio(1,PlayerHoming_Homing);
				}
				return;
			}
			if(%player.isHoming)
				return;
			%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
			initContainerBoxSearch(vectorAdd(%player.getPosition(),"0 0 -2"),"1 1 3",%mask); 
			%object = containerSearchNext();
			if(isObject(%object) && %object != SunLight.getId() && %object != %player.getId())
			{
				%player.canHome = 1;
				%player.mountImage(JumpBallImage,3);
			}
			else
			{
				%player.readyToHome = 0;
			}
			%player.readyToHome = 1;
			%player.canHomeSche = schedule(1000,0,HomingPlayer_canHome,%player,0);
		}
	}
	
	function PlayerHoming::onImpact(%this,%player,%col,%pos,%speed)
	{
		if(%player.isHoming && isObject(%col.client.minigame) && isObject(%player.client.minigame))
		{
			%col.kill();
			%player.setVelocity("0 0 10");
			%player.readyToHome = 1;
			%player.canHome = 1;
		}
		if(%col.getClassname() $= "FxDTSBrick" && %col = %player.HBTarget)
		{
			%player.readyToHome = 1;
			%player.canHome = 1;
		}
	}
	
	function FxDTSBrick::onPlayerTouch(%this,%brick,%player)
	{
		parent::onPlayerTouch(%this,%brick,%player);
		if(%brick == %player.HBTarget && %player.isHoming)
		{
			%player.readyToHome = 1;
			%player.canHome = 1;
			%player.setVelocity("0 0 0");
			%player.schedule(100,setVelocity,"0 0 20");
		}
	}
};
activatepackage(PlayerHoming);

function HomingPlayer_canHome(%player,%bool)
{
	%player.canHome = %bool;
	%player.readyToHome = %bool;
}

function HomingPlayer_BoostTick(%player)
{
	if(vectorDist(%player.getPosition(),%player.lastPos) < 1)
	{
		HomingPlayer_BoostStop(%player,"\c6You need to be moving to be able to \c4Boost!");
		return;
	}
	%player.lastPos = %player.getPosition();
	cancel(%player.boostTick);
	if(%player.getMountedImage(1) !$= BoostImage.getID())
		%player.mountImage(BoostImage,1);
	if(%player.boost < 1)
		{
			HomingPlayer_BoostStop(%player,"<just:center>\c6You ran out of \c4Boost\c6!");
		}
	if(!%player.isBoosting)
		return;
	if(%player.getDatablock() != PlayerHomingBoost.getID())
		%player.setDatablock(PlayerHomingBoost);
	%player.boost--;
	commandToClient(%player.client,'setVignette',0,"0 0 1 0.7");
	%player.client.bottomPrint("<just:center>\c6Boost\c6: "@%player.boost@"%",1);
	%player.boostTick = schedule(500,0,HomingPlayer_BoostTick,%player);
}

function HomingPlayer_BoostStop(%player,%msg)
{
	%player.playAudio(2,PlayerHoming_BoostEnd);
	%player.setDatablock(PlayerHoming);
	%player.client.bottomPrint(%msg,2,0);
	%player.isBoosting = 0;
	%player.unmountImage(1);
	commandToClient(%player.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
	return;
}

function HomingPlayer_stand(%player)
{
	%player.isHoming = 0;
	%player.playThread(0,"Root");
	%player.playThread(1,"Root");
}

function homingPlayer_nerfVel(%player)
{
	%player.setVelocity(vectorScale(%player.getVelocity,-3));
}

function HomingPlayer_cancelTick(%player)
{
	cancel(%player.homingSche);
	%player.playThread("Root",0);
	%player.playThread("Root",1);
}

function HomingPlayer_findClosestTarget(%player)
{
	%closestPlayer = 0;
	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%cl = clientGroup.getObject(%i);
		if(isObject(%cl.player) && %cl.player != %player)
		{
			if(%closestPosition $= "")
				%closestPosition = %cl.player.getPosition();
			if(vectorDist(%cl.player.getPosition(),%player.getPosition()) < vectorDist(%closestPosition,%player.getPosition()))
				%closestPosition = %cl.player.getPosition();
		}
	}
	for(%i=0;%i<HBTargets.getCount();%i++)
	{
		%brick = HBTargets.getObject(%i).brick;
		if(%closestPosition $= "")
			%closestPosition = %brick.getPosition();
		if(vectorDist(%brick.getPosition(),%player.getPosition()) < vectorDist(%closestPosition,%player.getPosition()) && isObject(%brick))
			%closestPosition = %brick.getPosition();
	}
	%dist = vectorDist(%closestPosition,%player.getPosition());
	if(%dist < 35)
		return %closestPosition;
	else
		return 0;
}