//Player_SonicLike
//By Wrapperup
//A Playertype that plays like modern sonic from Sonic Generations (plus spindash)

//Datablocks
datablock PlayerData(PlayerSonic : PlayerStandardArmor)
{
	runForce = 100 * 20;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 30;
   maxBackwardSpeed = 20;
   maxSideSpeed = 20;
   
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "Sonic-Like Player";
	showEnergyBar = false;
};

datablock PlayerData(PlayerSonicBoost : PlayerStandardArmor)
{
	runForce = 100 * 60;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 50;
   maxBackwardSpeed = 1;
   maxSideSpeed = 1;
   uiname = "";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	showEnergyBar = false;
};

datablock PlayerData(PlayerSonicRolling : PlayerStandardArmor)
{
	runForce = 2 * 90;
	canjet = 0;

	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;

	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 10;
	maxSideCrouchSpeed = 5;

	jumpForce = 0;

	friction = 0.15;
	uiname = "";
};

//Sounds

datablock AudioProfile(PlayerSonic_Homing)
{
	filename = "./homing.wav";
	description = AudioDefault3d;
	preload = true;
};

datablock AudioProfile(PlayerSonic_Boost:PlayerSonic_Homing)
{
	filename = "./boost.wav";
};

datablock AudioProfile(PlayerSonic_BoostEnd:PlayerSonic_Homing)
{
	filename = "./boost_end.wav";
};

datablock AudioProfile(PlayerSonic_AirStomp:PlayerSonic_Homing)
{
	filename = "./airstomp.wav";
};

datablock AudioProfile(PlayerSonic_AirStompLand:PlayerSonic_Homing)
{
	filename = "./airstomp_land.wav";
};

datablock AudioProfile(PlayerSonic_SpinDashRev:PlayerSonic_Homing)
{
	filename = "./SpinDash_Rev.wav";
};

datablock AudioProfile(PlayerSonic_SpinDashLaunch:PlayerSonic_Homing)
{
	filename = "./SpinDash_Launch.wav";
};

//Effects

datablock ParticleData(PlayerSonic_Particle)
{
   dragCoefficient = 0;
   gravityCoefficient = 0;
   inheritedVelFactor = 0;
   constantAcceleration = 0.0;
   lifetimeMS = 1000;
   lifetimeVarianceMS = 0;
   useInvAlpha = false;
   textureName = "./ballemitter.png";
   colors[0] = "1 1 1";
   colors[1] = "1 1 1";
   colors[2] = "1 1 1";
   sizes[0] = 2;
   sizes[1] = 2;
   sizes[2] = 0;
   times[0] = 0;
   times[1] = 0.9;
   times[2] = 1;
};

datablock ParticleEmitterData(PlayerSonic_Emitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   ejectionOffset = 0;
   velocityVariance = 0;
   thetaMin = 0;
   thetaMax = 0;
   phiReferenceVel = 0;
   phiVariance = 0;
   overrideAdvance = true;
   particles = "PlayerSonic_Particle";
   uiName = "BlueBallTest";
};

datablock ShapeBaseImageData(PlayerSonic_Image)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;
	
	offset = "0 0 -0.5";
	
	mountPoint = 2;
	
	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "Next";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "Next";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 1;
	stateEmitter[1]					= PlayerSonic_Emitter;
	stateEmitterTime[1]				= 1;
};

//Events

registerInputEvent(fxDtsBrick,"onStomp","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent(fxDtsBrick,"onHomeAttack","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent(fxDtsBrick,"onSpinDashed","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");

//Functions

function Player::groundCheck(%this,%maskset)
{
	if(%maskset $= "")
		%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
	if(%maskset == 1)
		%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
	initContainerBoxSearch(vectorAdd(%this.getPosition(),"0 0 -1.2"),"1 1 3",%mask);
	%object = containerSearchNext();
	if(isObject(%object) && %object != SunLight.getId() && %object != %this.getId())
		return 1;
	return 0;
}

function Player::HomeAttack(%this)
{
	%pos = %this.getPosition();
	%radius = 30;
	if(%this.cantHome)
		return;

	%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType;
	initContainerRadiusSearch(%pos,%radius,%mask);
	while((%target = containerSearchNext()) != 0)
	{
		echo(%target);
		if(%target == %this)
			continue;
		if(%target.getName() $= "_PSHomeBrick" && %target.getClassName() $= "fxDTSBrick")
		{
			if(!%target.isFakeDead())
				break;
		}
		if(%target.getClassName() $= "AIPlayer" && %target.getDatablock().maxDamage > %target.getDamageLevel())
			break;
			
		if(%target.getClassName() $= "Player" && %target.getDatablock().maxDamage > %target.getDamageLevel())
			break;
	}
	if(!isObject(%target))
	{
		%this.homeTarget = -1;
		PlayerSonic_NoTargetHome(%this);
		echo("no target");
	}
	else
	{
		if(%target.getClassName() $= "fxDTSBrick")
			%target.enableTouch = 1;
		echo("got target");
		%this.homeTarget = %target;
		PlayerSonic_TickHome(%this,0);
		PlayerSonic_doAnimSound(%this,1);
	}
}

function Player::addBoost(%this,%ammount)
{
	%this.boost += %ammount;
	%this.client.bottomPrint("\c6You got \c4"@%ammount@"\c6 boost points!",2);
}

function Player::setBoost(%this,%ammount)
{
	%this.boost = %ammount;
	%this.client.bottomPrint("\c6You now have \c4"@%ammount@"\c6 boost points.",2);
}

function PlayerSonic_TickHome(%player,%times)
{
	if(%times > 20 || !isObject(%player.homeTarget) || %player.stopHoming)
	{
		while(isEventPending(%player.stopSchedule))
			cancel(%player.HomestopSchedule);
		%player.HomestopSchedule = schedule(50,0,%player.setVelocity("0 0 15"));
		PlayerSonic_doAnimSound(%player,0);
		%player.stopHoming = 0;
		%player.isHoming = 0;
		%player.canHome = 1;
		return;
	}
	if(%player.isHoming == 0)
		%player.isHoming = 1;
	%vel = vectorScale(vectorNormalize(vectorSub(%player.homeTarget.getPosition(),%player.getPosition())),60);
	%player.setVelocity(%vel);
	echo("tick");
	%times++;
	%player.homeSche = schedule(100,0,PlayerSonic_TickHome,%player,%times);
}

function PlayerSonic_NoTargetHome(%player)
{
	%forwardvel = vectorScale(%player.getForwardVector(),30);
	%vel = getWords(%forwardvel,0,1) SPC "7";
	%player.isHoming = 1;
	%player.setVelocity(%vel);
	PlayerSonic_doAnimSound(%player,1);
	schedule(1000,0,PlayerSonic_doAnimSound,%player,0);
	%player.schedule(2000,0,setVelocity,"0 0 0");
}

function PlayerSonic_doAnimSound(%player,%a)
{
	if(%a)
	{
		%player.mountImage(PlayerSonic_Image,3);
		%player.playAudio(1,PlayerSonic_Homing);
		%player.playThread(1,"sit");
		%player.playThread(2,"armReadyBoth");
	}
	else
	{
		%player.unMountImage(3);
		%player.playThread(1,"Root");
		%player.playThread(2,"Root");
		%player.updateArm();
		if(%player.isHoming)
			%player.isHoming = 0;
	}
}

function PlayerSonic_DownDashTick(%player)
{
	if(%player.groundCheck(1) || %player.stopStomping)
	{
		%player.playAudio(1,PlayerSonic_AirStompLand);
		%player.stopStomping = 0;
		%player.cantHome = 0;
		%player.isStomping = 0;
		return;
	}
	if(!%player.cantHome)
		%player.cantHome = 1;
	%player.isStomping = 1;
	%player.setVelocity("0 0 -40");
	%player.downSche = schedule(250,0,PlayerSonic_DownDashTick,%player);
}

function PlayerSonic_rollingLoop(%player)
{
	%speed = vectorLen(%player.getVelocity());
	if(%speed < 4)
	{
		%player.setDatablock(PlayerSonic);
		PlayerSonic_doAnimSound(%player,0);
		%player.isRolling = 0;
		return;
	}
	if(%player.getDatablock().getName() !$= "PlayerSonicRolling")
		%player.setDatablock(PlayerSonicRolling);
	if(!%player.isRolling)
		%player.isRolling = 1;
	%player.mountImage(PlayerSonic_Image,3);
	%player.rollSche = schedule(250,0,PlayerSonic_rollingLoop,%player);
}

function PlayerSonic_BoostTick(%player)
{
	%speed = vectorLen(%player.getVelocity());
	if(%speed < 1)
	{
		PlayerSonic_BoostStop(%player,"\c6You need to be moving to be able to \c4Boost!");
		return;
	}
	%player.lastPos = %player.getPosition();
	cancel(%player.boostTick);
	if(%player.getMountedImage(1) != PlayerSonic_Image.getID())
		%player.mountImage(PlayerSonic_Image,1);
	if(%player.boost < 1)
		{
			PlayerSonic_BoostStop(%player,"<just:center>\c6You ran out of \c4Boost\c6!");
		}
	if(!%player.isBoosting)
		return;
	if(%player.getDatablock() != PlayerSonicBoost.getID())
		%player.setDatablock(PlayerSonicBoost);
	%player.boost--;
	commandToClient(%player.client,'setVignette',0,"0 0 1 0.7");
	%player.client.bottomPrint("<just:center>\c6Boost\c6: "@%player.boost@"%",1);
	%player.boostTick = schedule(500,0,PlayerSonic_BoostTick,%player);
}

function PlayerSonic_BoostStop(%player,%msg)
{
	%player.playAudio(2,PlayerSonic_BoostEnd);
	%player.setDatablock(PlayerSonic);
	%player.client.bottomPrint(%msg,2,0);
	%player.isBoosting = 0;
	%player.unmountImage(1);
	commandToClient(%player.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
	return;
}

//Package

package SonicLikePlayer
{
	function PlayerSonic::onCollision(%this,%obj,%col,%pos,%vel)
	{
		echo("collision!");
		parent::onCollision(%this,%obj,%col,%pos,%vel);
		if(%obj.getClassName() $= "Player")
		{
			if(%obj.isHoming)
			{
				echo("yes YES");
				if(%col == %obj.homeTarget)
				{
					if(%col.getClassName() $= "AIPlayer")
					{
						%col.kill();
						%obj.canHome = 1;
					}
					if(%col.getClassName() $= "Player")
					{
						if(%obj.client.minigame == %col.client.minigame)
							%col.kill();
						%obj.canHome = 1;
					}
				}
				%obj.stopHoming = 1;
			}
			
			if(%obj.isStomping)
			{
				echo("stompd");
				if(%col.getClassName() $= "AIPlayer")
				{
					%col.kill();
				}
				if(%col.getClassName() $= "Player")
				{
					if(%obj.client.minigame == %col.client.minigame)
						%col.kill();
				}
				%obj.stopStomping = 1;
			}
		}
	}
	
	function PlayerSonicRolling::onCollision(%this,%obj,%col,%pos,%vel)
	{
		parent::onCollision(%this,%obj,%col,%pos,%vel);
		if(%obj.getClassName() $= "Player")
		{
			if(%obj.isRolling)
			{
				echo("rold");
				%speed = vectorLen(%obj.getVelocity());
				if(%speed > 7)
				{
					if(%col.getClassName() $= "AIPlayer")
					{
						%col.kill();
					}
					if(%col.getClassName() $= "Player")
					{
						if(%obj.client.minigame == %col.client.minigame)
							%col.kill();
					}
				}
			}
		}
	}
	
	function fxDTSBrick::onPlayerTouch(%this,%player,%brick)
	{
		parent::onPlayerTouch(%this,%player,%brick);
		if(%player.isHoming && %player.getDatablock().getName() $= "PlayerSonic")
		{
			$inputTarget_Self = %this;
			$inputTarget_Player = %player;
			$inputTarget_Client = %player.client;
			$inputTarget_Minigame = getMinigameFromObject(%player.client);
			%this.processInputEvent("onHomeAttack",%player.client);
			echo("Hit");
			%player.stopHoming = 1;
		}
		
		if(%player.isStomping && %player.getDatablock().getName() $= "PlayerSonic")
		{
			$inputTarget_Self = %this;
			$inputTarget_Player = %player;
			$inputTarget_Client = %player.client;
			$inputTarget_Minigame = getMinigameFromObject(%player.client);
			%this.processInputEvent("onStomp",%player.client);
			echo("Hit");
		}
	}
	
	function PlayerSonicRolling::onTrigger(%this,%player,%slot,%val)
	{
		parent::onTrigger(%this,%player,%slot,%val);
		if(%slot == 2 && %val)
		{
			if(isEventPending(%player.rollSche))
			cancel(%player.rollSche);
			PlayerSonic_doAnimSound(%player,0);
			%player.setDatablock(PlayerSonic);
		}
	}
	
	function PlayerSonicBoost::onTrigger(%this,%player,%slot,%val)
	{
		parent::onTrigger(%this,%player,%slot,%val);
		if(%slot == 4 && !%val)
		{
			if(%player.isBoosting)
			{
				%player.isBoosting = 0;
				cancel(%player.boostTick);
				%player.unmountImage(1);
				%player.setDatablock(PlayerSonic);
				commandToClient(%player.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
			}
			%player.playAudio(2,PlayerSonic_BoostEnd);
		}
	}
	
	function PlayerSonic::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot == 0 && %val)
		{
			if(%player.attemptSpinDash)
			{
				if(%player.spinDashCharge < 100)
				{
					%player.spinDashCharge += 25;
					echo(%player.spindashCharge);
				}
				%player.mountImage(PlayerSonic_Image,3);
				%player.playAudio(1,PlayerSonic_SpinDashRev);
				return;
			}
		}
		if(%slot == 4)
		{
			if(%val)
			{
				if(!%player.isHoming && !%player.isStomping)
				{
					%player.isBoosting = 1;
					if(%player.boost > 0)
					{
						%player.setVelocity(getWords(vectorScale(%player.getForwardVector(),50),0,1) SPC getWord(%player.getVelocity(),2));
						PlayerSonic_BoostTick(%player);
						%player.playAudio(2,PlayerSonic_Boost);
					}
					else
					{
						%player.client.bottomPrint("<just:center>\c6You ran out of\c4 Boost\c6!",2);
					}
				}
				else
				{
					%player.client.bottomPrint("<just:center>\c6You cant \c4Boost\c6 while doing a special move!",2);
				}
			}
		}
		%parent = parent::onTrigger(%this,%player,%slot,%val);
		if(%slot == 3)
		{
			if(%val)
			{
				if(%player.isHoming)
				{
					if(isObject(%player.homeTarget))
						%player.stopHoming = 1;
					else
						PlayerSonic_doAnimSound(%player,0);
				}
				if(!%player.groundCheck() && !%player.isStomping)
				{
					%player.playAudio(1,PlayerSonic_AirStomp);
					PlayerSonic_DownDashTick(%player);
				}
				else if(!%player.isStomping)
				{
					%speed = vectorLen(%player.getVelocity());
					if(%speed > 2)
					{
						%player.playThread(1,"sit");
						%player.playThread(2,"armReadyBoth");
						%player.playAudio(1,PlayerSonic_SpinDashLaunch);
						PlayerSonic_rollingLoop(%player);
					}
				}
			}
			else
			{
				if(%player.attemptSpinDash && %player.spinDashCharge > 0)
				{
					%player.playThread(1,"sit");
					%player.playThread(2,"armReadyBoth");
					%player.setVelocity(vectorScale(%player.getForwardVector(),%player.spinDashCharge));
					%player.spinDashCharge = 0;
					%player.playAudio(1,PlayerSonic_SpinDashLaunch);
					PlayerSonic_rollingLoop(%player);
				}
			}
			if(%speed < 2)
			{
				%player.attemptSpinDash = %val;
			}
		}
		if(%slot == 2 && %val)
		{
			if(%player.canHome && !%player.groundCheck())
			{
				if((getSimTime() - %this.homeAttackTime) < 750)
					return;
				%this.homeAttackTime = getSimTime();
				%player.HomeAttack();
				%player.canHome = 0;
				return;
			}
			if(%player.groundCheck())
			{
				%player.canHome = 1;
			}
		}
	}
};
activatepackage(SonicLikePlayer);